


#define Version "190627"
#define HIGH_SPEED
//  32MHz interne ( 8x4 PLL)
// activation CLKROUT =>RA6 Pin15 CLKROUT
// note 1 : ne pas activer Clockout dans la config bits !
// note 2 : SQA analyser plafonne en dessous de 60ns
// RA2=DACOUT

//#define Version "170726"
// avec  Hardware  UART
// RB2 = TX
// RB1 =RX
// traitement RX It
// config 16MHZ FOSC interne
//16LF1847_Fosc_Interne_16MHz.cfgsch
//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1613


 //ac:Pinout_16F1847

#define Directory " C:\\_MikroC\\_MesProjets_MikroC\\_16F1847_UART_RB2_TX_RB1_RX_interrupt"
#define Project "16F1847_test_CLKROut_RA6_Uart_RB2_RB1_RX_interrupt.mcppi"
#define Source "_16F1847_UART_RB2_RB1_RX_Interrupt_test_CLRKout"
#define Use_Cable_Prolic_TTL_USB

#define Oscillateur_Interne
#define MCU "16F1827"
#define Power_Supply "3,3V  5 V"



#ifdef HIGH_SPEED
#define FOSC "32"   // MHz
#define CONFIG  "16F1847_Fosc_Interne_8MHz_x_PLL_32MHz.cfgsch"
#else
#define FOSC "16"   // MHz
#define CONFIG  "16F1847_Fosc_Interne_16MHz.cfgsch"
#endif


//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1613

   //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define BELL 7
#define Byte unsigned char
#define uint8 unsigned char

#define MaxBuffer 64
volatile unsigned char buffer[MaxBuffer];   
volatile unsigned  char * p1;
volatile int Index1;
volatile  unsigned char c1;
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int i1;

volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;
volatile int Flag_Buffer;
unsigned long clk =0;


char Texte[64];
char *txt;
unsigned char CRam1[32];
unsigned int i,j,k;

sbit Led at LATA.B4 ;
sbit Led_Direction at TRISA.B4;          // RA4
sbit Synchro_SQ50 at LATB.B3 ;
sbit Synchro_SQ50_Direction at TRISB.B3; // RAB3

sbit OUT_Freq at LATA.B6 ;
sbit OUT_Freq_Dir at TRISA.B6;

unsigned char Diviseur,Duty;
unsigned char Gamme_Diviseur[]={1,2,4,8,16,32,64,128};
unsigned char Gamme_Duty[]={0,25,50,75};


void interrupt(void)  org 0x04
{
  if ( (RCIE_bit) && ( RCIF_bit))
   {
   //TXREG='*';
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)  // ||   (i1>=MaxBuffer-2))
      {
      Flag_Buffer=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source)
 {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}


void putch(unsigned char d)
{
    while (!TXIF) ;          // wait until TXREG empty
    TXREG = d;           // send character
}


void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
}


void Init_Hardware()
{

 PORTA=0;
 PORTB=0;
 ANSELA = 0;        //Set PORTA  digital  I/O
 TRISA=0b10100111; // RA3, RA4,RA6 as output
 OUT_Freq_Dir=0;
 Led_Direction=0;
 Led=1;

 ANSELB = 0;         //Set PORTB as digital I/O
 TRISB=0b11100011;  // all input   excpet RB4  ,RB3
 Synchro_SQ50_Direction=0;

 APFCON0=0;  // ALTERNATE PIN FUNCTION CONTROL REGISTER 0// page 119
 APFCON0.RXDTSEL=0;
 // RXDTSEL=0  RX/DT function is on RB1
 // SDO1SEL=0  SDO1 function is on RB2
 // SS1SEL =0  SS1 function is on RB5
 // P2BSEL =0  P2B function is on RB7
 // CCP2SEL =0 CCP2/P2A function is on RB6
 // P1DSEL= 0  P1D function is on RB7
 // P1CSEL= 0  P1C function is on RB6
 // CCP1SEL= 0 CCP1/P1A function is on RB3
 APFCON1=0; // ALTERNATE PIN FUNCTION CONTROL REGISTER 1
 APFCON1.TXCKSEL=0; //  TX/CK function is on RB2

 CM1CON0=0;       // disable comparators
 CM1CON1=0;
 CM2CON0=0;       // disable comparators
 CM2CON1=0;
 FVRCON.FVREN=0;  // disble fixed voltage reference
 EECON1.EEPGD=0;  // is the control register for EE memorya Accesses.
 // Option REG
 //  WPUEN INTEDG TMR0CS TMR0SE PSA PS<2:0>
 OPTION_REG=0;
 OPTION_REG.WUE=0;  // // WPUEN=0 enable all pull up
 WPUB=0xFF;
 //INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF
 INTCON.PEIE=1;
 // PIE1
 //TMR1GIE ADIE RCIE TXIE SSP1IE CCP1IE TMR2IE TMR1IE
 PIE1=0;  // deja a zero sur reset
 // PIR1: PERIPHERAL INTERRUPT REQUEST REGISTER 1
 // TMR1GIF ADIF RCIF TXIF SSP1IF CCP1IF TMR2IF TMR1IF
 PIR1=0;    // deja a zero sur reset
 //   INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF p89
 INTCON.IOCIE=0;  // disable interrupt PORTB
 INTCON.GIE=0;
 }

void Raz_UART_Buffer()
{
  int i;
  Flag_Buffer=0;
  for (i=0;i<31;i++) buffer[i]=0;
  Index1=0;
  i1=0;
  c1=RCREG;  // efface flag RCIF si lev
  c1=0;
  p1=buffer;
  PIE1.RCIE=1;
 }

unsigned char cx;

void main() 
{
  // without PLL
  //OSCCON = 0b01111010;     // fosc interne 16 MHz No PLL
  // -----------------------------------------------------
  
  //SPLLEN
  //If PLLEN in Configuration Words = 0:
  //1 = 4x PLL Is enabled
  //0 = 4x PLL is disabled
  SPLLEN_bit=1;
  //  IRCF<3:0>
  //1110 = 8 MHz or 32 MHz HF(see Section 5.2.2.1 HFINTOSC)
  IRCF3_bit=1;    IRCF2_bit=1;  IRCF1_bit=1;  IRCF0_bit=0;
 //bit 1-0 SCS<1:0>: System Clock Select bits
 // 1x = Internal oscillator block  except when use of PLL
   SCS1_bit=0;  SCS0_bit=0;
  // OSCCON=  0b11110010;    // 1-1110-00  8 Mhz x PLL =32MHz
// OSCTUNE=0x1F; //maxima  FOSC
  OSCTUNE=0x00; // nominal FOSC
// OSCTUNE=0x2F; //minima  FOSC
  
  //----------------------------------------------------
  // 6.0 REFERENCE CLOCK MODULE
  // REGISTER 6-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER
  //CLKRCON CLKREN CLKROE CLKRSLR CLKRDC<1:0> CLKRDIV<2:0>
  //CLKREN: Reference Clock Module Enable bit
  CLKREN_bit=1;
  //1 = Reference Clock output is enabled on CLKR pin
  CLKROE_bit=1;
  //CLKRSLR: Reference Clock Slew Rate Control Limiting Enable bit
  CLKRSLR_bit=0;
  //CLKRDC<1:0>: Reference Clock Duty Cycle bits
  Duty=2; //50%
   CLKRCON= CLKRCON & 0xE7;
   CLKRCON= CLKRCON | (Duty<<3)  ;  // Duty 0  3
    //CLKRDIV<2:0> Reference Clock Divider bits
   Diviseur=4; // 16
  CLKRCON=CLKRCON & 0xF8;
  CLKRCON=CLKRCON | Diviseur; // diviseur 0  7   ( 0  128)




  
  Init_Hardware();
  Delay_ms(100);
 // init pointeur zones textes
  txt=&Texte[0];
  p1=&buffer[0];

  UART1_Init(19200);
  UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle); // set UART1 active
  while(PIR1.RCIF==1) c1 = RCREG;
  UART1_Write(CLS);
  Delay_ms(1000);
  
    clk = Get_Fosc_kHz();


   UART1_Write_CText(" Directory: "Directory"\r\n");
   UART1_Write_CText(" Projet: "Project"\r\n");
   UART1_Write_CText(" Source : "Source"_"Version".c\r\n");
   UART1_Write_CText(" Alimentation : "Power_Supply"\r\n");
   UART1_Write_CText(" UART1 19200,8,N,1  RB2=TX->Display terminal  Keyboard=RB1=RX\r\n");
   UART1_Write_CText(" Config :" CONFIG"\r\n FOSC = "FOSC"\r\n");
   LongWordToStr(clk,CRam1);
   UART1_Write_CText(" Get_Fosc_Khz = "); UART1_Write_Text(CRam1);  CRLF1();
   strConstRamCpy(txt, "\r\n Test Reception UART sur RB1 \r\n"),
   UART1_Write_Text(txt) ;
   UART1_Write_CText(" et test REFERENCE CLOCK MODULE , sortie sur RA6 pin 15 \r\n");
   UART1_Write_CText(" avec SQ50 Analyser ,synchro via RB3\r\n");
   CRLF1();

    UART1_Write_CText(" Init sortie CLKR Out  Diviseur =");
    ByteToStr(Gamme_Diviseur[Diviseur],CRam1);
    UART1_Write_Text(CRam1); 
    UART1_Write_CText(" Duty= ");
    ByteToStr(Gamme_Duty[Duty],CRam1);
    UART1_Write_Text(CRam1); CRLF1();



  UART1_Write_CText(" ADC Init sur RA0\r\n");
  ADC_Init();

  strConstRamCpy(txt, "\r\n Mesure sur ADC0 en attendant Reception UART sur RB1 \r\n"),
  UART1_Write_Text(txt) ;
  CRLF1();

  Raz_UART_Buffer();
  GIE_bit=1;

while(1)
 {
    Delay_ms(1000);
 
   if ( Flag_Buffer==1)
   {
     UART1_Write_CText("Reception de : ");
     UART1_Write_Text(buffer); 
     CRLF1();
     p1=strstr(buffer,"DIV=");
     if (p1>0)
     {
      cx=*(p1+4);
       if ((cx>='0') && (cx<'8'))
       {
        Diviseur=cx-48;
        CLKRCON=CLKRCON & 0xF8;
        CLKRCON=CLKRCON | Diviseur; // diviseur 0  7   ( 0  128)
        UART1_Write_CText(" \r\n New Diviseur= ");
         ByteToStr(Gamme_Diviseur[Diviseur],CRam1);
         Synchro_SQ50=1;
         UART1_Write_Text(CRam1); CRLF1();
        }
        else
         UART1_Write_CText(" \r\n Err saisie  : 0<=  Diviseur < 8\r\n ");
     p1=0;
     }
     
      p1=strstr(buffer,"DUT=");
     if (p1>0)
     {
       cx=*(p1+4);
     if ((cx>='0') && (cx<'4'))
     {
     
        Duty=cx-48;
        CLKRCON= CLKRCON & 0xE7;
         CLKRCON= CLKRCON | (Duty<<3)  ;  // Durty 0  3
         UART1_Write_CText(" \r\n New Duty = ");
         ByteToStr(Gamme_Duty[Duty],CRam1);
         UART1_Write_Text(CRam1); CRLF1();
       }
        else
         UART1_Write_CText(" \r\n Err saisie :  0<= Duty <4\r\n ");
     p1=0;
     }
     
     p1=strstr(buffer," LED_ON");
     if (p1>0) 
     {
      Led=1;
      p1=0;
      }
     p1=strstr(buffer," LED_OFF");
     if (p1>0)
      {
      Led=0;
      p1=0;
      }
       cx=0;
      Raz_UART_Buffer();
     //PIE1.RCIE=1;
   }

   Synchro_SQ50=1;
   UART1_Write_CText("  Diviseur= "); ByteToStr(Gamme_Diviseur[Diviseur],CRam1);  UART1_Write_Text(CRam1);
   UART1_Write_CText("  Duty = "); ByteToStr(Gamme_Duty[Duty],CRam1); UART1_Write_Text(CRam1);
   Synchro_SQ50=0;
    k=ADC_Read(0) ;
   WordToStr(k,CRam1); UART1_Write_CText("   ADC0= ");    UART1_Write_Text(CRam1);
    CRLF1();


 }
}

/*

  Directory:  C:\_MikroC\_MesProjets_MikroC\_16F1847_UART_RB2_TX_RB1_RX_interrupt
 Projet: 16F1847_test_CLKROut_RA6_Uart_RB2_RB1_RX_interrupt.mcppi
 Source : _16F1847_UART_RB2_RB1_RX_Interrupt_test_CLRKout_190627.c
 Alimentation : 3,3V  5 V
 UART1 19200,8,N,1  RB2=TX->Display terminal  Keyboard=RB1=RX
 Config :16F1847_Fosc_Interne_8MHz_x_PLL_32MHz.cfgsch
 FOSC = 32
 Get_Fosc_Khz =      32000

 Test Reception UART sur RB1
 et test REFERENCE CLOCK MODULE , sortie sur RA6 pin 15
 avec SQ50 Analyser ,synchro via RB3

 Init sortie CLKR Out  Diviseur = 16 Duty=  50
 ADC Init sur RA0

 Mesure sur ADC0 en attendant Reception UART sur RB1
  Diviseur=  16  Duty =  50   ADC0=   351      ON =240nS  OFF=260nS
  Diviseur=  16  Duty =  50   ADC0=   306

//mesures effectues  29C amb... et OSCCTUNE=0;

Reception de : DIV=1       16MHz
 New Diviseur=   2     ==>  NON MESURABLE
  Diviseur=   2  Duty =  50   ADC0=   688
  Diviseur=   2  Duty =  50   ADC0=   703

 Reception de :  DIV=2        8Mhz
 New Diviseur=   4            ON=60ns  OFF=60nS
  Diviseur=   4  Duty =  50   ADC0=   414
  Diviseur=   4  Duty =  50   ADC0=   445

 Reception de : DIV=3        4Mhz
 New Diviseur=   8           ON=120ns  OFF=120nS
  Diviseur=   8  Duty =  50   ADC0=   335
  Diviseur=   8  Duty =  50   ADC0=   421


 Reception de :  DIV=4     2Mhz
 New Diviseur=  16          ON=240ns  OFF=240nS
  Diviseur=  16  Duty =  50   ADC0=   418
  Diviseur=  16  Duty =  50   ADC0=   421

Reception de : DIV=5       1MHz
 New Diviseur=  32         ON=500ns  OFF=500nS
  Diviseur=  32  Duty =  50   ADC0=   417
  Diviseur=  32  Duty =  50   ADC0=   381

  Reception de :  DIV=6    500Khz
  New Diviseur=  64      ON=1S  OFF=1S
  Diviseur=  64  Duty =  50   ADC0=   368
  Diviseur=  64  Duty =  50   ADC0=   266


  Reception de : DIV=7      250 Khz
  New Diviseur= 128     ==> 2S ON  + 2S  OFF
  Diviseur= 128  Duty =  50   ADC0=   530
  Diviseur= 128  Duty =  50   ADC0=   373

  Reception de : DUT=1
  New Duty =  25
  Diviseur= 128  Duty =  25   ADC0=   223
  Diviseur= 128  Duty =  25   ADC0=   182
  
   Diviseur= 128  Duty =  75   ADC0=   275

 Reception de : DUT=3
 New Duty =  75
  Diviseur= 128  Duty =  75   ADC0=   263
  Diviseur= 128  Duty =  75   ADC0=   338
  Diviseur= 128  Duty =  75   ADC0=   339



*/